<ui:composition xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml"
>

    <ui:define name="body">

        <h:form id="globalForm">
            <h1>#{messages['gazelle.simulator.pam.encounterInformation']}</h1>
            <s:div rendered="#{encounterManager.encounter == null or empty encounterManager.encounter}">
                <h:outputText value="#{messages['gazelle.simulator.pam.NotAValidEncounterId']}"
                              styleClass="gzl-alert gzl-alert-red"/>
            </s:div>
            <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                        rendered="#{encounterManager.encounter != null and not empty encounterManager.encounter}">
                <ui:define name="panel_title">#{encounterManager.encounter.visitNumber}</ui:define>
                <ui:define name="panel_footer">
                    <a4j:commandButton value="#{messages['gazelle.simulator.pam.createWorklist4Encounter']}"
                                       action="#{encounterManager.redirectToWorklistPage()}"
                                       rendered="#{encounterManager.isWorklistEnabled()}"
                                       styleClass="gzl-btn-blue"/>
                </ui:define>
                <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.HL7Common.simulatedActor']}</ui:define>
                        <h:outputText value="#{encounterManager.encounter.simulatedActor.name}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.creator != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.Creator']}</ui:define>
                        <h:outputText value="#{encounterManager.getUserName(encounterManager.encounter.creator)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.creationDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.CreationDate']}</ui:define>
                        <g:date value="#{encounterManager.encounter.creationDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.visitNumber != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.VisitNumber']}</ui:define>
                        <h:outputText value="#{encounterManager.encounter.visitNumber}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.Patient']}</ui:define>
                        <h:outputLink
                                value="#{applicationConfiguration.getValueOfVariable('application_url')}/patient.seam?id=#{encounterManager.encounter.patient.id}"
                                target="_blank">
                            <h:outputText value="#{encounterManager.encounter.patient.firstName}
                            #{encounterManager.encounter.patient.lastName}
                            (#{encounterManager.encounter.getPatientClass()})"/>
                        </h:outputLink>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.id != null}">
                        <ui:define name="label">#{messages['gazelle.HL7Common.permanentLink']}</ui:define>
                        <h:outputLink
                                value="#{applicationConfiguration.getValueOfVariable('application_url')}/encounter.seam?id=#{encounterManager.encounter.id}"
                                target="_blank">
                            <h:outputText
                                    value="#{applicationConfiguration.getValueOfVariable('application_url')}/encounter.seam?id=#{encounterManager.encounter.id}"/>
                        </h:outputLink>
                    </s:decorate>
                </dl>
            </s:decorate>
            <!-- General informations (status/dates) -->
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simulator.pam.GeneralInformations']}</ui:define>
                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.PatientStatus']}</ui:define>
                        <h:outputText value="#{encounterManager.encounter.patientStatus.name}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.pam.AdmissionType']}</ui:define>
                        <h:outputText
                                value="#{valueSet.getDisplayNameForCode('HL70007', encounterManager.encounter.admissionType)}"/>
                    </ui:decorate>
                </dl>
                <s:div rendered="#{encounterManager.encounter.accidentDate != null}">
                    <h:outputText value="#{messages['gazelle.pam.PatientHasBeenAdmittedFollowingAnAccident']}"/>
                    <dl class="dl-horizontal">
                        <ui:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['gazelle.pam.AccidentCode']}</ui:define>
                            <h:outputText
                                    value="#{valueSet.getDisplayNameForCode('HL70050', encounterManager.encounter.accidentCode)}"/>
                        </ui:decorate>
                        <ui:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['gazelle.pam.AccidentDate']}</ui:define>
                            <g:date value="#{encounterManager.encounter.accidentDate}"/>
                        </ui:decorate>
                    </dl>
                </s:div>
                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.HospitalService']}</ui:define>
                        <h:outputText value="#{encounterManager.encounter.hospitalServiceCode}"/>
                    </ui:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.expectedAdmitDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.ExpectedAdmissionDatetime']}
                        </ui:define>
                        <g:date value="#{encounterManager.encounter.expectedAdmitDate}"/>
                    </s:decorate>
                    <ui:decorate template="/layout/display/_display.xhtml"
                                 rendered="#{encounterManager.encounter.admitDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.AdmissionDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.admitDate}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_display.xhtml"
                                 rendered="#{encounterManager.encounter.transferPlannedDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.TransferPlannedDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.transferPlannedDate}"/>
                    </ui:decorate>
                </dl>
                <h:outputText value="#{messages['gazelle.simulator.pam.PatientIsGoneForALeaveOfAbsence']}"
                              rendered="#{encounterManager.encounter.leaveOfAbsence}"/>
                <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.leaveOfAbsenceDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.LeaveOfAbsenceDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.leaveOfAbsenceDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.expectedLOAReturn != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.ExpectedReturnDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.expectedLOAReturn}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.loaReturnDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.LoaReturnDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.loaReturnDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.expectedDischargeDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.ExpectedDischargeDatetime']}
                        </ui:define>
                        <g:date value="#{encounterManager.encounter.expectedDischargeDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{encounterManager.encounter.dischargeDate != null}">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.DischargeDatetime']}</ui:define>
                        <g:date value="#{encounterManager.encounter.dischargeDate}"/>
                    </s:decorate>
                </dl>
            </ui:decorate>
            <!-- doctors -->
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simulator.pam.Doctors']}</ui:define>
                <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.AttendingDoctor']}</ui:define>
                        <h:outputText
                                value="#{valueSet.getDisplayNameForCode('DOCTOR', encounterManager.encounter.attendingDoctorCode)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.simulator.pam.ReferringDoctor']}</ui:define>
                        <h:outputText
                                value="#{valueSet.getDisplayNameForCode('DOCTOR', encounterManager.encounter.referringDoctorCode)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.patientmanager.AdmittingDoctor']}</ui:define>
                        <h:outputText
                                value="#{valueSet.getDisplayNameForCode('DOCTOR', encounterManager.encounter.admittingDoctorCode)}"/>
                    </s:decorate>
                </dl>
            </ui:decorate>
            <s:div rendered="#{encounterManager.displayBP6Attributes()}">
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">#{messages['gazelle.pam.DRGMovement']}</ui:define>
                    <ui:include src="/fr/_displayDRGMovement.xhtml">
                        <ui:param name="drg" value="#{encounterManager.encounter.drgMovement}"/>
                    </ui:include>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">#{messages['gazelle.pam.AddtionalEncounterInformation']}</ui:define>
                    <ui:include src="/fr/_displayAdditionalEncounterInfo.xhtml">
                        <ui:param name="zfv" value="#{encounterManager.encounter.encounterAdditionalInfo}"/>
                    </ui:include>
                </ui:decorate>
                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">#{messages['gazelle.pam.PatientsPHR']}</ui:define>
                    <ui:include src="/fr/_displayPatientsPHR.xhtml">
                        <ui:param name="phr" value="#{encounterManager.encounter.patientsPHRInfo}"/>
                    </ui:include>
                </ui:decorate>
            </s:div>
            <!-- movements -->
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simulator.pam.MovementsHistoric']}</ui:define>
                <rich:dataTable value="#{encounterManager.encounter.movements}" var="movement"
                                render="ds" id="tableId">
                    <g:column id="movementId">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.MovementUniqueId']}</ui:define>
                        #{movement.movementUniqueId}
                    </g:column>
                    <g:column id="movementDate">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.MovementDate']}</ui:define>
                        <g:date value="#{movement.movementDate}"/>
                    </g:column>
                    <g:column id="triggerEvent">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.TriggerEvent']}</ui:define>
                        <div class="gzl-never-wrap">
                            <h:outputText value="#{movement.triggerEvent}"/>
                            <s:span styleClass="fa fa-hourglass-end gzl-text-blue"
                                    rendered="#{not(movement.actionType.isCancel()) and not movement.currentMovement and not movement.pendingMovement}"
                                    title="Historic movement"/>
                            <s:span styleClass="fa fa-hourglass-start gzl-text-blue"
                                    rendered="#{not(movement.actionType.isCancel()) and movement.pendingMovement}"
                                    title="Pending movement"/>
                            <s:span styleClass="fa fa-hourglass-half gzl-text-blue"
                                    rendered="#{not(movement.actionType.isCancel()) and movement.currentMovement}"
                                    title="Current movement"/>
                            <s:span styleClass="fa fa-ban gzl-text-blue"
                                    rendered="#{movement.actionType.isCancel()}"
                                    title="Movement cancelled"/>
                        </div>
                    </g:column>
                    <g:column id="action">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.Action']}</ui:define>
                        <h:outputText value="#{movement.actionType.label}"
                                      styleClass="gzl-label #{movement.actionType.styleClass}"/>
                    </g:column>
                    <g:column id="lastChangedDate">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.LastChanged']}</ui:define>
                        <g:date value="#{movement.lastChanged}"/>
                    </g:column>
                    <g:column id="creator">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.Creator']}</ui:define>
                        #{movement.creator}
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.pam.Actions']}</ui:define>
                        <a4j:commandLink actionListener="#{encounterManager.setSelectedMovement(movement)}"
                                         oncomplete="jq162('#movementDetailPanel').modal('show');"
                                         title="#{messages['gazelle.pam.ShowDetails']}"
                                         render="movementDetailPanelContent, movementDetailPanel">
                            <s:span styleClass="gzl-icon-search"/>
                        </a4j:commandLink>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="tableId"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </ui:decorate>
            <!-- rich modal panel which enables the user to choose which identifier send to the OrderManager -->
            <ui:include src="/iti31/movementDetails.xhtml">
                <ui:param name="movement" value="#{encounterManager.selectedMovement}"/>
            </ui:include>
        </h:form>
    </ui:define>
</ui:composition>